import { sinon } from '@genesislcap/foundation-testing';

export const mockFdc3 = () => {
  if (!('fdc3' in window)) {
    const broadcast = sinon.stub();
    const addContextListener = sinon.stub();
    const channel = {
      getCurrentContext: async () => ({}),
      broadcast,
      addContextListener,
    };

    window.fdc3 = {
      broadcast,
      channel,
      addContextListener,
      findIntent: sinon.spy(),
      findIntentsByContext: sinon.spy(),
      getOrCreateChannel: sinon.stub().returns(channel),
      getInfo: () => ({ fdc3Version: '2.1', provider: 'FINOS' }),
      joinChannel: sinon.spy(),
      raiseIntent: sinon.stub(),
      raiseIntentForContext: sinon.stub(),
      addIntentListener: sinon.spy(),
      getCurrentChannel: sinon.stub().returns(channel),
    };
  }
};

export const removeMockFdc3 = () => {
  if (!('fdc3' in window)) {
    delete window['fdc3'];
  }
};
